'*****************************************************************************
'Classe SenyalaTram: Enmagarzema tots els senyals d'un tram. A partir de cada
'senyal es generar una imatge raster per cada una de elles
'*****************************************************************************
Option Explicit On

Imports GDO = Intergraph.GeoMedia.GDO
Imports PPipe = Intergraph.GeoMedia.PPipe

Public Class SenyalsTram

    'Declaraci de variables de l'objecte
    Private idTram As Integer
    Private velocitat As Integer
    Private peatonal As Integer
    Private cBici As Integer
    Private escala As Integer
    Dim sentit() As Integer
    Dim polilinia As New PolylineGeometry
    Dim pnt As New PBasic.point
    Dim s As Senyal
    Dim posicio As Integer

    'Declaraci de constants per la crida de objectes Senyal
    'Tipus de senyal
    Const V_0 As String = "VELOCITAT 0"
    Const V_10 As String = "VELOCITAT 10"
    Const V_20 As String = "VELOCITAT 20"
    Const V_30 As String = "VELOCITAT 30"
    Const V_40 As String = "VELOCITAT 40"
    Const PAS_V As String = "PAS DE VIANANTS"
    Const C_BICI As String = "CARRIL BICI"
    Const C_PEATONAL As String = "CARRER PEATONAL"
    Const SENTIT_0 As String = "DOBLE SENTIT"
    Const SENTIT_1 As String = "SENTIT 1"
    Const SENTIT_2 As String = "SENTIT 2"

    'Nom del arxiu del senyal
    Const PATH_V_10 As String = "C:/TFC/IMAGES/velocitat_10.jpg"
    Const PATH_V_20 As String = "C:/TFC/IMAGES/velocitat_20.jpg"
    Const PATH_V_30 As String = "C:/TFC/IMAGES/velocitat_30.jpg"
    Const PATH_V_40 As String = "C:/TFC/IMAGES/velocitat_40.jpg"
    Const PATH_PAS_V As String = "C:/TFC/IMAGES/PasV.jpg"
    Const PATH_C_BICI As String = "C:/TFC/IMAGES/cBici.jpg"
    Const PATH_C_PEATONAL As String = "C:/TFC/IMAGES/cPeatonal.jpg"
    Const PATH_SENTIT_0 As String = "C:/TFC/IMAGES/sentit_0.jpg"
    Const PATH_SENTIT_1 As String = "C:/TFC/IMAGES/sentit_1.jpg"
    Const PATH_SENTIT_2 As String = "C:/TFC/IMAGES/sentit_2.jpg"

    '------------------------------------------------------------------------------------------
    'Constructor de la Classe SenyalsCarrils.
    '------------------------------------------------------------------------------------------
    Public Sub New(ByVal nIdTram As Integer, ByVal nVelocitat As Integer, _
    ByVal nPeatonal As Integer, ByVal nCBici As Integer, ByVal nEscala As Integer)

        scIdTram = nIdTram
        scVelocitat = nVelocitat
        scPeatonal = nPeatonal
        scCBici = nCBici
        scEscala = nEscala

    End Sub

    '--------------------------------------------------------------------------------
    ' Getters i Setters
    '--------------------------------------------------------------------------------
    Public Property scIdTram() As Integer
        Get
            Return idTram
        End Get
        Set(ByVal idTr As Integer)
            idTram = idTr
        End Set
    End Property

    Public Property scVelocitat() As Integer
        Get
            Return velocitat
        End Get
        Set(ByVal vel As Integer)
            velocitat = vel
        End Set
    End Property

    Public Property scPeatonal() As Integer
        Get
            Return peatonal
        End Get
        Set(ByVal peat As Integer)
            peatonal = peat
        End Set
    End Property

    Public Property scCBici() As Integer
        Get
            Return cBici
        End Get
        Set(ByVal bici As Integer)
            cBici = bici
        End Set
    End Property

    Public Property scEscala() As Integer
        Get
            Return escala
        End Get
        Set(ByVal escal As Integer)
            escala = escal
        End Set
    End Property

    '-------------------------------------------------------------------------------------------
    'Procediment setSentit: substitueix al setter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Sub setSentit(ByVal sent As Integer, ByVal k As Integer)

        Try
            ReDim sentit(k)
            sentit(k) = sent
        Catch ex As NullReferenceException
            MsgBox("NullreferenceException. SenyalsTram.setSentit()")
            MsgBox(ex.Message)
        End Try

    End Sub

    '-------------------------------------------------------------------------------------------
    'Procediment getSentit: substitueix al getter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Function getSentit(ByVal k As Integer) As Integer

        Dim ret As Integer
        ret = sentit(k)

        Return ret

    End Function

    '---------------------------------------------------------------------------------------------
    'Funci longSentit(): Retorna la mida de l'array on desem el sentit de circulaci de cada tram
    '---------------------------------------------------------------------------------------------
    Function longSentit() As Integer

        Dim l As Integer

        Try
            l = UBound(sentit)
        Catch ex As NullReferenceException
            MsgBox("NullreferenceException")
        End Try

        Return l

    End Function

    '-------------------------------------------------------------------------------------------
    'Funci generarPolilinia(): Genera una polilinia a partir dels punts extrets. Aquesta 
    'polilinia equival als Trams. Sobre aquesta polilinia farem els calculs per crear el poligon.
    '-------------------------------------------------------------------------------------------
    Sub generarPolilinia(ByVal x As Double, ByVal y As Double)

        pnt.X = x
        pnt.Y = y
        polilinia.Points.Add(pnt)

    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode senyalSentit(): Genera un objecte Senyal i el posiciona en el carril corresponent
    '-------------------------------------------------------------------------------------------
    Sub senyalSentit(ByVal n As Integer)
        'Els senyals de velocitat es collocaran a 10 mts del comenament del tram en els sentit
        'de marxa. en cas de doble sentit (sentit = 0), es collocar en ambdos extrems.

        '**************************************************************************************
        'Aquest mtode no s'ha implementat per motius explicats en la memria
        '**************************************************************************************

        posicio = 10

        s = Nothing

        Select Case n

            Case 0
                s = New Senyal(scIdTram(), PATH_SENTIT_0, SENTIT_0)

            Case 1
                s = New Senyal(scIdTram(), PATH_SENTIT_1, SENTIT_1)

            Case 2
                s = New Senyal(scIdTram(), PATH_SENTIT_2, SENTIT_2)

        End Select

    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode senyalVelocitat(): Genera un objecte Senyal i el posiciona en el carril corresponent
    '-------------------------------------------------------------------------------------------
    Sub senyalVelocitat(ByVal v As Integer, ByVal tram As Tram2D)
        'Els senyals de velocitat es collocaran a 8 mts del comenament del tram en els sentit
        'de marxa. en cas de doble sentit (sentit = 0), es collocar en ambdos extrems.

        Dim i As Integer, sentit As Integer
        Dim liniaS1 As New PolylineGeometry, liniaS2 As New PolylineGeometry

        posicio = -8

        s = Nothing

        Select Case v

            Case 10
                s = New Senyal(tram.tIdTram(), PATH_V_10, V_10)

            Case 20
                s = New Senyal(tram.tIdTram(), PATH_V_20, V_20)

            Case 30
                s = New Senyal(tram.tIdTram(), PATH_V_30, V_30)

            Case 40
                s = New Senyal(tram.tIdTram(), PATH_V_40, V_40)

                'Hauriem d'afegir la resta de velocitats si n'hi haguessin ms
            Case Else

                'En cas d'errors en la velocitat (hi ha un item als exemples amb velocitat = 41)
                'no dem res
                s = Nothing

        End Select

        s.sPosicio = posicio
        s.sEscala = tram.tEscala

        'Collocarem un senyal en cada carril
        For i = 1 To tram.longLiniesTram() - 1
            liniaS1 = tram.getLiniesTram(i + 1)
            liniaS2 = tram.getLiniesTram(i)
            sentit = tram.getSentit(i)
            'Calculem el punt on volem colocar la linia
            Select Case sentit
                Case 0 'Doble sentit. Un senyal a cada extrem
                    s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
                    s.sP2 = generarPunt2(s.sP1)
                    frmTFC1.inserirSenyal(s)

                    s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
                    s.sP2 = generarPunt2(s.sP1)
                    frmTFC1.inserirSenyal(s)

                Case 1 'Sentit esquerra-dreta
                    s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
                    s.sP2 = generarPunt2(s.sP1)
                    frmTFC1.inserirSenyal(s)

                Case 2 'Sentit dreta-esquerra
                    s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
                    s.sP2 = generarPunt2(s.sP1)
                    frmTFC1.inserirSenyal(s)

            End Select
        Next

    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode senyalPasV(): Genera un objecte Senyal i el posiciona en el carril corresponent
    '-------------------------------------------------------------------------------------------
    Sub senyalPasV(ByVal tram As Tram2D)
        'Els senyals de  pas de vianants es collocaran a 2 mts dels dos extrems del tram.
        'Colocarem el senyal al mig del tram

        Dim liniaS1 As New PolylineGeometry, liniaS2 As New PolylineGeometry
        Dim n As Integer

        posicio = -4

        s = Nothing

        s = New Senyal(tram.tIdTram(), PATH_PAS_V, PAS_V)

        n = tram.longLiniesTram
        liniaS1 = tram.getLiniesTram(n)
        liniaS2 = tram.getLiniesTram(1)

        s.sPosicio = posicio
        s.sEscala = tram.tEscala

        s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
        s.sP2 = generarPunt2(s.sP1)
        frmTFC1.inserirSenyal(s)

        s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
        s.sP2 = generarPunt2(s.sP1)
        frmTFC1.inserirSenyal(s)



    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode senyalCBici(): Genera un objecte Senyal i el posiciona en el carril corresponent
    '-------------------------------------------------------------------------------------------
    Sub senyalCBici(ByVal tram As Tram2D)
        'Els senyals de carril bici es collocaran a 5 mts del comenament del tram en els sentit
        'de marxa. En cas de doble sentit (sentit = 0), es collocar en ambdos extrems.

        Dim sentit As Integer
        Dim liniaS1 As New PolylineGeometry, liniaS2 As New PolylineGeometry

        posicio = -5

        s = Nothing

        ' Els carrils bici tenen un sol carril
        sentit = tram.getSentit(1)
        liniaS1 = tram.getLiniesTram(2)
        liniaS2 = tram.getLiniesTram(1)

        s = New Senyal(tram.tIdTram(), PATH_C_BICI, C_BICI)
        s.sPosicio = posicio
        s.sEscala = tram.tEscala

        Select Case sentit
            Case 0 'Doble sentit 0. Un senyal a cada extrem
                s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
                s.sP2 = generarPunt2(s.sP1)
                frmTFC1.inserirSenyal(s)

                s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
                s.sP2 = generarPunt2(s.sP1)
                frmTFC1.inserirSenyal(s)

            Case 1 'Sentit 1 esquerra-dreta
                s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
                s.sP2 = generarPunt2(s.sP1)
                frmTFC1.inserirSenyal(s)

            Case 2 ' Sentit 2 dreta-esquerra
                s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
                s.sP2 = generarPunt2(s.sP1)
                frmTFC1.inserirSenyal(s)

            Case Else

        End Select

    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode senyalCPeatonal(): Genera un objecte Senyal i el posiciona en el carril corresponent
    '-------------------------------------------------------------------------------------------
    Sub senyalCPeatonal(ByVal tram As Tram2D)

        'Els senyals de carril peatonal es collocaran a 3 mts del comenament del tram en els sentit
        'de marxa. Es collocaran en ambdos extrems.
        Dim liniaS1 As New PolylineGeometry, liniaS2 As New PolylineGeometry

        posicio = -3

        s = Nothing

        s = New Senyal(tram.tIdTram(), PATH_PAS_V, PAS_V)

        'Els carrers peatonals tenen un sol carril
        liniaS1 = tram.getLiniesTram(2)
        liniaS2 = tram.getLiniesTram(1)
        s.sPosicio = posicio
        s.sEscala = tram.tEscala

        s.sP1 = generarPunt1(s, liniaS1, liniaS2, 1)
        s.sP2 = generarPunt2(s.sP1)
        frmTFC1.inserirSenyal(s)

        s.sP1 = generarPunt1(s, liniaS1, liniaS2, 2)
        s.sP2 = generarPunt2(s.sP1)
        frmTFC1.inserirSenyal(s)

    End Sub

    '-------------------------------------------------------------------------------------------
    'Mtode generarPunt1(): Genera un punt sobre la linia del carril per posicionar-ho la imatge 
    'Senyal. Ens cales 2 punts per posicionar-la. Aquest mtode calcula el primer
    '-------------------------------------------------------------------------------------------
    'Function generarPunt1(ByVal s As Senyal, ByVal linia As PolylineGeometry, ByVal tipus As Integer) As PBasic.point
    Function generarPunt1(ByVal s As Senyal, ByVal linia1 As PolylineGeometry, ByVal linia2 As PolylineGeometry, _
    ByVal tipus As Integer) As PBasic.point
        Dim pt As New PBasic.point, p1 As New PBasic.point, p2 As New PBasic.point, vect As New PBasic.point
        Dim modul As Double, x2 As Double, y2 As Double, pc As Double, mod2 As Double
        Dim n As Integer

        Select Case tipus
            Case 1 'Extrem p1 de la linia
                'p1 = Linia.Points.Item(1)
                'p2 = Linia.Points.Item(2)
                p1 = linia1.Points.Item(1)
                p2 = linia2.Points.Item(1)

                'Calculem el vector
                vect.X = p1.X - p2.X
                vect.Y = p1.Y - p2.Y
                '....
                vect.X = vect.X / 2
                vect.Y = vect.Y / 2

                pt.X = p2.X + vect.X
                pt.Y = p2.Y + vect.Y

                'Calculem el modul
                x2 = vect.X * vect.X
                y2 = vect.Y * vect.Y

                modul = Math.Sqrt(x2 + y2)
                pc = escala * s.sPosicio
                mod2 = modul / pc

                pt.X = pt.X - (vect.Y / mod2)
                pt.Y = pt.Y + (vect.X / mod2)


            Case 2 'Extrem pn de la linia
                'n = Linia.Points.Count
                'p1 = Linia.Points.Item(n)
                'p2 = Linia.Points.Item(n - 1)
                n = linia1.Points.Count
                p1 = linia1.Points.Item(n)
                p2 = linia2.Points.Item(n)

                'Calculem el vector
                vect.X = p1.X - p2.X
                vect.Y = p1.Y - p2.Y
                '...
                vect.X = vect.X / 2
                vect.Y = vect.Y / 2

                pt.X = p2.X + vect.X
                pt.Y = p2.Y + vect.Y

                'Calculem el modul
                x2 = vect.X * vect.X
                y2 = vect.Y * vect.Y

                modul = Math.Sqrt(x2 + y2)
                pc = escala * s.sPosicio
                mod2 = modul / pc

                pt.X = pt.X + (vect.Y / mod2)
                pt.Y = pt.Y - (vect.X / mod2)


        End Select

        'Ajustem el punt
        pt.X = pt.X - s.sEscala
        pt.Y = pt.Y - s.sEscala

        Return pt

    End Function

    '-------------------------------------------------------------------------------------------
    'Mtode generarPunt2(): Genera el segon punt a partir del primer punt per posicionar la imatge 
    'Senyal. Donem a la imatge una mida de 2x2 mts per la escala
    '-------------------------------------------------------------------------------------------
    Function generarPunt2(ByVal punt1 As PBasic.point) As PBasic.point

        Dim pt As New PBasic.point

        pt.X = punt1.X + (2 * s.sEscala)
        pt.Y = punt1.Y + (2 * s.sEscala)

        Return pt

    End Function

End Class
