'*****************************************************************************
'Classe Tram2D: genera un polgon que ser una representaci en 2D del tram.
'Un cop s'hagi creat el polgon, omplir els camps de la taula TRAMS2D de la
' BBDD de sortida outputDB
'*****************************************************************************

Imports PBasic = Intergraph.GeoMedia.PBasic

Public Class Tram2D

    'Declaraci de variables de l'objecte
    Private idTram As Integer, escala As Integer, nCarrils As Integer
    Private nom As String, descr As String
    Private ampladaTram As Double
    Dim polilinia As New PolylineGeometry
    Dim poligon As New PolygonGeometry
    Dim punt As New PBasic.point
    Dim carrils() As Double
    Dim sentit() As Integer
    Dim liniesTram() As PolylineGeometry
    Dim liniaC As Linia
    Dim pLinia As New PolylineGeometry

    'Declaraci de variables diverses
    Dim n As Integer, n2 As Integer, i As Integer, j As Integer, k As Integer, m As Integer
    Dim w As Integer

    '--------------------------------------------------------------------------------
    ' Constructor Tram2D
    '--------------------------------------------------------------------------------
    Public Sub New(ByVal nIdTram As Integer, ByVal nNom As String, _
    ByVal nDescr As String, ByVal nCarrils As Integer, ByVal nEscala As Integer)

        tIdTram = nIdTram
        tNom = nNom
        tDescr = nDescr
        tNCarrils = nCarrils
        tEscala = nEscala
        tAmpladaTram = 0

    End Sub

    '--------------------------------------------------------------------------------
    ' Getters i Setters
    '--------------------------------------------------------------------------------
    Public Property tIdTram() As Integer
        Get
            Return idTram
        End Get
        Set(ByVal tram As Integer)
            idTram = tram
        End Set
    End Property

    Public Property tNom() As String
        Get
            Return nom
        End Get
        Set(ByVal name As String)
            nom = name
        End Set
    End Property

    Public Property tDescr() As String
        Get
            Return descr
        End Get
        Set(ByVal description As String)
            descr = description
        End Set
    End Property

    Public Property tNCarrils() As Integer
        Get
            Return nCarrils
        End Get
        Set(ByVal nCarr As Integer)
            nCarrils = nCarr
        End Set
    End Property

    Public Property tEscala() As Integer
        Get
            Return escala
        End Get
        Set(ByVal esca As Integer)
            escala = esca
        End Set
    End Property

    Public Property tAmpladaTram() As Double
        Get
            Return ampladaTram
        End Get
        Set(ByVal aTram As Double)
            ampladaTram = aTram
        End Set
    End Property

    Public Property tPoligon() As PolygonGeometry
        Get
            Return poligon
        End Get
        Set(ByVal plg As PolygonGeometry)
            poligon = plg
        End Set
    End Property

    '-------------------------------------------------------------------------------------------
    'Procediment setCarril: substitueix al setter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Sub setCarril(ByVal ampleCarril As Double, ByVal k As Integer)

        Try
            ReDim carrils(k)
            carrils(k) = ampleCarril
            tAmpladaTram() = tAmpladaTram() + ampleCarril
        Catch ex As NullReferenceException
            MsgBox("NullreferenceException. SenyalsTram.setSentit()")
            MsgBox(ex.Message)
        End Try

    End Sub

    '-------------------------------------------------------------------------------------------
    'Procediment getSentit: substitueix al getter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Function getCarril(ByVal k As Integer) As Integer

        Dim ret As Integer

        ret = carrils(k)

        Return ret

    End Function

    '-------------------------------------------------------------------------------------------
    'Procediment setSentit: substitueix al setter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Sub setSentit(ByVal sent As Integer, ByVal k As Integer)

        Try
            ReDim sentit(k)
            sentit(k) = sent
        Catch ex As NullReferenceException
            MsgBox("NullreferenceException. SenyalsTram.setSentit()")
            MsgBox(ex.Message)
        End Try

    End Sub

    '-------------------------------------------------------------------------------------------
    'Procediment getSentit: substitueix al getter habitual ja que getter i setter funcionen 
    'diferent.
    '-------------------------------------------------------------------------------------------
    Function getSentit(ByVal k As Integer) As Integer

        Dim ret As Integer
        ret = sentit(k)

        Return ret

    End Function

    '-------------------------------------------------------------------------------------------
    'Procediment getLiniesTram: substitueix al getter habitual
    '-------------------------------------------------------------------------------------------
    Function getLiniesTram(ByVal k As Integer) As PolylineGeometry

        Dim ret As PolylineGeometry
        ret = liniesTram(k)

        Return ret

    End Function

    '---------------------------------------------------------------------------------------------
    'Funci longLiniesTram(): Retorna la mida de l'array on desem les linies de cada tram
    '---------------------------------------------------------------------------------------------
    Function longLiniesTram() As Integer

        Dim l As Integer

        Try
            l = UBound(liniesTram)
        Catch ex As NullReferenceException
            MsgBox("NullreferenceException")
        End Try

        Return l

    End Function

    '-------------------------------------------------------------------------------------------
    'Procediment generarPolilinia(): Genera una polilinia a partir dels punts extrets. Aquesta 
    'polilinia equival als Trams. Sobre aquesta polilinia farem els calculs per crear el poligon.
    '-------------------------------------------------------------------------------------------
    Sub generarPolilinia(ByVal x As Double, ByVal y As Double)

        punt.X = x
        punt.Y = y
        polilinia.Points.Add(punt)

    End Sub

    '--------------------------------------------------------------------------------------------
    ' Procediment generarPoligon(): Genera un polgon a partir d'una polilnea, amb una amplada
    ' totals del polgon que ser l'amplada dels trams per l'escala elegida. 
    '--------------------------------------------------------------------------------------------
    Sub generarPoligon()

        Dim pt1 As New PBasic.point, pt2 As New PBasic.point, pt3 As New PBasic.point
        Dim vt As New PBasic.point, vect As New PBasic.point, pt As New PBasic.point
        Dim modul As Double, amp As Double

        pt1 = Nothing
        pt2 = Nothing
        pt3 = Nothing

        'Si la polilinia representa la part central del carril llavors la meitat de l'ample ser 
        'l'amplada a afegir per cada costat
        amp = (tAmpladaTram() * escala) / 2

        n = polilinia.Points.Count
        Try ' Controlem les excepcions

            '--------------------------------------------------------------------
            ' Passem d'una polilnia a un polgon                               |
            '                                     p1------p2---...------pn      |
            '   p1---p2--...----pn    ----->       |                     |      |
            '                                     pn2----pn2-1-...-----pn+1     |
            '--------------------------------------------------------------------

            n2 = n * 2
            k = 1
            i = 1
            '-----------------------------------------------------------------------------------
            'Calculem el punt "superior" del primer extrem (p1).
            'Tenim un vector entre els punts p1 i p2, i calculem un vector a 90 d'aquest vector
            'per obternir el punt
            pt1 = polilinia.Points.Item(1)
            pt2 = polilinia.Points.Item(2)

            vect = generarVector(pt1, pt2)
            modul = generarModul(vect, amp)

            ' Inserim p1
            poligon.Points.Add(generarParalel(modul, vect, pt1, 1))
            i = i + 1
            '-----------------------------------------------------------------------------
            'Calculem els punts intermitjos "superiors" (de p2 fins pn-1).
            'A partir de 3 punts, obtenim el vector dels punts pi-1 i pi+1 per obtenir el
            'vector de pi, i calculem el punt amb un vector a 90 sobre el vector obtingut.
            '(En cas de polgons de 4 punts, aquest pas es salta)
            While (i < n)
                pt1 = polilinia.Points.Item(i - 1)
                pt2 = polilinia.Points.Item(i)
                pt3 = polilinia.Points.Item(i + 1)

                vect = generarVector(pt1, pt3)
                modul = generarModul(vect, amp)

                'Insertem de p2 fins pn-1
                poligon.Points.Add(generarParalel(modul, vect, pt2, 1))
                i = i + 1

            End While
            '----------------------------------------------------------------------
            'Calculem els punts del segon extrem (pn i pn+1).
            'Sobre el vector de pn-1 i pn de la polilinia, calculem el vector a 90 
            'per obtenir el punt pn i el vector a -90 per obtenir el punt pn+1
            pt1 = polilinia.Points.Item(n - 1)
            pt2 = polilinia.Points.Item(n)

            vect = generarVector(pt1, pt2)
            modul = generarModul(vect, amp)

            'Insertem pn
            poligon.Points.Add(generarParalel(modul, vect, pt2, 1))

            'Insertem pn+1
            poligon.Points.Add(generarParalel(modul, vect, pt2, 2))
            i = i - 1
            '-------------------------------------------------------------------------------
            'Part "inferior" del polgon de pn+2 fins pn2-1
            'Calculem els punts intermitjos "inferiors" (de pn+2 fins pn2-1)
            'A partir de 3 punts, obtenim el vector dels punts pi-1 i pi+1 per obtenir el
            'vector de pi, i calculem el punt amb un vector a -90 sobre el vector obtingut.
            '(En cas de polgons de 4 punts, aquest punt es salta)
            While (i > 1) 'Ja s'ha fet de p1 fins pn
                pt1 = polilinia.Points.Item(i - 1)
                pt2 = polilinia.Points.Item(i)
                pt3 = polilinia.Points.Item(i + 1)

                vect = generarVector(pt1, pt3)
                modul = generarModul(vect, amp)

                'Insertem de pn+2 fins a pn2-1
                poligon.Points.Add(generarParalel(modul, vect, pt2, 2))
                i = i - 1
            End While

            '------------------------------------------------------------------------------------
            'Calculem el punt "inferior" del primer extrem (pn2)
            'Tenim un vector entre els punts p1 i p2, i calculem un vector a -90 d'aquest vector
            'per obternir el punt
            pt1 = polilinia.Points.Item(1)
            pt2 = polilinia.Points.Item(2)

            vect = generarVector(pt1, pt2)
            modul = generarModul(vect, amp)

            'Insertem pn2
            poligon.Points.Add(generarParalel(modul, vect, pt1, 2))

            'Capturem les excepcions
        Catch ex As NullReferenceException
            MsgBox("NullReferenceException: Tram2D.generarPoligon()")
            MsgBox(ex.Message)
        Catch ex As ArgumentException
            MsgBox("ArgumentException: Tram2D.generarPoligon()")
            MsgBox(ex.Message)
        Catch ex As AccessViolationException
            MsgBox("AccessViolationException: Tram2D.generarPoligon()")
            MsgBox(ex.Message)
        End Try

    End Sub

    '--------------------------------------------------------------------------------------------
    ' Funci generarVector(): Genera un vector entre dos punts i el desem en un altre punt. 
    '--------------------------------------------------------------------------------------------
    Function generarVector(ByVal pt1 As PBasic.point, ByVal pt2 As PBasic.point) As PBasic.point

        Dim vt As New PBasic.point

        vt.X = pt1.X - pt2.X
        vt.Y = pt1.Y - pt2.Y

        Return vt

    End Function

    '--------------------------------------------------------------------------------------------
    'Funci generarModul(): Genera el mdul del vector entre dos punts. Ample fa referencia a
    'l'escala de representaci
    '--------------------------------------------------------------------------------------------
    Function generarModul(ByVal vt As PBasic.point, ByVal ample As Double) As Double

        Dim x2 As Double, y2 As Double, modul As Double, modRet As Double

        'Per alguna ra que no he pogut esbrinar, la formula:
        '   modul = Math.Sqrt((vt.X * vt.X) + (vt.Y * vt.Y))
        'em donava resultat negatiu en cas que el punt de vector fos negatiu ?
        'Per tant, he hagut d'optar per insertar pas intermedi perque no em passi.
        x2 = vt.X * vt.X
        y2 = vt.Y * vt.Y

        modul = Math.Sqrt(x2 + y2)
        modRet = modul / ample

        Return modRet

    End Function

    '--------------------------------------------------------------------------------------------
    'Funci generarParalel(): Genera els dos punts paralels al punt de la polilnia per obtenir
    'els punts del polgon. Segons si el punt es de la part "superior" del polgon o de la part
    '"inferior" prenem l'opci 1 o 2 respectivament. 
    '--------------------------------------------------------------------------------------------
    Function generarParalel(ByVal mod2 As Double, ByVal vec As PBasic.point, ByVal pt As PBasic.point, _
    ByVal tipusPunt As Integer) As PBasic.point

        Dim pRet As New PBasic.point

        Select Case tipusPunt
            Case 1
                'Punt "superior" 
                pRet.X = pt.X - (vec.Y / mod2)
                pRet.Y = pt.Y + (vec.X / mod2)

            Case 2
                'Punt "inferior"
                pRet.X = pt.X + (vec.Y / mod2)
                pRet.Y = pt.Y - (vec.X / mod2)

        End Select

        Return pRet

    End Function

    '--------------------------------------------------------------------------------------------
    'Mtode generarLiniesCarrils(): Genera les lnies separadores dels carrils. Les linies 
    'externes i les que separin carrils en sentit contrari generaran linia continua, la resta, 
    'discontinua
    '--------------------------------------------------------------------------------------------
    Sub generarLiniesCarrils()

        Dim x As Double, y As Double, modul As Double, ample As Double
        Dim pt1 As New PBasic.point, pt2 As New PBasic.point, pt3 As New PBasic.point
        Dim vect As New PBasic.point, pt As New PBasic.point
        Dim l As Integer

        Try
            'Generem les linies externes del tram
            'Generem la linia "superior" de p1 a pn
            liniaC = New Linia(tIdTram(), 1)
            l = UBound(sentit)
            ReDim liniesTram(l + 1)

            ' n ja es el n de punts del tram original. Queda desat i el fem servir
            For m = 1 To n
                x = poligon.Points.Item(m).X
                y = poligon.Points.Item(m).Y
                liniaC.generarPolilinia(x, y)
            Next

            liniaC.lPolilinia = ajustarExtremsLinia(liniaC.lPolilinia)
            liniesTram(1) = liniaC.lPolilinia
            frmTFC1.generarLiniaContinua(liniaC)

            'Generen les lnies intermitjes
            'Generem els carrils paralel de "dalt" a "baix"
            For w = 2 To l
                m = 1
                'Prenem la darrera linia creada com a base
                pLinia = liniaC.lPolilinia
                liniaC = Nothing
                liniaC = New Linia(tIdTram, w)

                'Generem paralel de p1
                pt1 = pLinia.Points.Item(1)
                pt2 = pLinia.Points.Item(2)

                ample = carrils(w) * escala

                vect = generarVector(pt1, pt2)
                modul = generarModul(vect, ample)

                pt = generarParalel(modul, vect, pt1, 2)
                liniaC.generarPolilinia(pt.X, pt.Y)

                'Generem els parallels de p1+1 fin a pn-1. Si la linia t dos punts, salta proces
                m = m + 1
                While (m < n)
                    pt1 = pLinia.Points.Item(m - 1)
                    pt2 = pLinia.Points.Item(m)
                    pt3 = pLinia.Points.Item(m + 1)

                    vect = generarVector(pt1, pt3)
                    modul = generarModul(vect, ample)

                    pt = generarParalel(modul, vect, pt2, 2)
                    liniaC.generarPolilinia(pt.X, pt.Y)

                    m = m + 1
                End While

                'Generem el punt palarel de pn
                pt1 = pLinia.Points.Item(n - 1)
                pt2 = pLinia.Points.Item(n)

                vect = generarVector(pt1, pt2)
                modul = generarModul(vect, ample)

                pt = generarParalel(modul, vect, pt2, 2)
                liniaC.generarPolilinia(pt.X, pt.Y)

                liniesTram(w) = liniaC.lPolilinia

                'Si els dos carrils tenen el mateix sentit de marxa, generem linia discontinua.
                'Si son diferents, generem linia continua.
                If getSentit(w) <> getSentit(w - 1) Then
                    frmTFC1.generarLiniaContinua(liniaC)
                Else
                    frmTFC1.generarLiniaDiscontinua(liniaC)
                End If

            Next

            'Generem la linia "inferior" de pn+1 a pn2
            liniaC = New Linia(tIdTram(), tNCarrils())
            For m = n2 To n + 1 Step -1
                x = poligon.Points.Item(m).X
                y = poligon.Points.Item(m).Y
                liniaC.generarPolilinia(x, y)
            Next

            liniaC.lPolilinia = ajustarExtremsLinia(liniaC.lPolilinia)
            liniesTram(l + 1) = liniaC.lPolilinia
            frmTFC1.generarLiniaContinua(liniaC)


        Catch ex As NullReferenceException
            MsgBox("NullReferenceException: Tram2D.generarLiniesCarrils()")
            MsgBox(ex.Message)
        Catch ex As ArgumentException
            MsgBox("ArgumentException: Tram2D.generarLiniesCarrils()")
            MsgBox(ex.Message)
        Catch ex As AccessViolationException
            MsgBox("AccessViolationException: Tram2D.generarLiniesCarrils()")
            MsgBox(ex.Message)
        Catch ex As IndexOutOfRangeException
            MsgBox("IndexOutOfRangeException: Tram2D.generarLiniesCarrils(), Tram " & tIdTram())
            MsgBox(ex.Message)
        End Try
    End Sub

    '--------------------------------------------------------------------------------------------
    'Funci ajustarExtremsLinia(): Ajusta els extrems de les linies de senyalitzaci 
    '(LINIACONTINUA i LINIADISCONTINUA) per tal que no es creuin en una cruilla
    '--------------------------------------------------------------------------------------------
    Function ajustarExtremsLinia(ByVal linia As PolylineGeometry) As PolylineGeometry

        Dim pt As New PBasic.point, pt1 As PBasic.point, pt2 As PBasic.point, vt As PBasic.point
        Dim ample As Double, modul As Double
        Dim n As Integer

        ample = (3.5 * tEscala) / 2
        n = linia.Points.Count

        'Ajustem el primer extrem de la linia (pt1)
        pt1 = linia.Points.Item(1)
        pt2 = linia.Points.Item(2)

        vt = generarVector(pt1, pt2)
        modul = generarModul(vt, ample)

        pt.X = pt1.X - (vt.X / modul)
        pt.Y = pt1.Y - (vt.Y / modul)

        linia.Points.Item(1).X = pt.X
        linia.Points.Item(1).Y = pt.Y

        'Ajustem el segon extrem de la linia (ptn)
        pt1 = linia.Points.Item(n)
        pt2 = linia.Points.Item(n - 1)

        vt = generarVector(pt1, pt2)
        modul = generarModul(vt, ample)

        pt.X = pt1.X - (vt.X / modul)
        pt.Y = pt1.Y - (vt.Y / modul)

        linia.Points.Item(n).X = pt.X
        linia.Points.Item(n).Y = pt.Y

        Return linia

    End Function


End Class
