Option Explicit On

Imports GDO = Intergraph.GeoMedia.GDO
Imports PPipe = Intergraph.GeoMedia.PPipe


Public Class frmTFC1

    'Declarem de variables per control de BBDD
    Dim inputDB As GDO.GDatabase
    Dim outputDB As GDO.GDatabase
    Dim gmTbl As GDO.GTableDef
    Dim gmFld As GDO.GField
    Dim gmRS_IN_T2D As GDO.GRecordset
    Dim gmRS_IN_ST As GDO.GRecordset
    Dim gmRS_OUT_T2D As GDO.GRecordset
    Dim gmRS_OUT_SENY As GDO.GRecordset
    Dim gmRS_OUT_LC As GDO.GRecordset
    Dim gmRS_OUT_LD As GDO.GRecordset
    Dim gmGSS As New GeometryStorageService
    Dim QueryString As String
    Dim inputPath As String
    Dim outputPath As String

    Dim imputDBError As GDO.GError
    Dim outputDBError As GDO.GError
    Dim errorMessage As String

    'Declarem les variables  globals
    Dim escala As Integer

    'Decalrem les variables d'objectes geomtrics
    Dim polyg As New Object
    'Dim poligon As PolygonGeometry
    Dim punt As New PBasic.point
    'Dim raster As New Object
    '----------------------------------------------------------------------------

    'Declarem les variables que indiquen si una senyalitzaci es representar (TRUE) o no (FALSE)
    Dim snySentit As Boolean, snyVelocitat As Boolean, snyPasV As Boolean
    Dim snyCBus As Boolean, snyCBici As Boolean, snyCPeatonal As Boolean

    'Constants de les taules existents
    Const CARRILS As String = "CARRILS"
    Const CRUILLES As String = "CRUILLES"
    Const TRAMS As String = "TRAMS"
    Const ID1 As String = "ID1"
    Const IDTRAM As String = "IDTRAM"
    Const NOM As String = "NOM"
    Const DESCR As String = "DESCR"
    Const AMPLE As String = "AMPLE"
    Const DIRECCIO As String = "DIRECCIO"
    Const VELOCITAT As String = "VELOCITAT"
    Const PEATONAL As String = "PEATONAL"
    Const CBICI As String = "CBICI"
    Const SENTIT As String = "SENTIT"
    Const ESCALAT As String = "ESCALA"
    Const TIPUS As String = "TIPUS"
    Const CARRIL As String = "CARRIL"
    Const GEOMETRY As String = "GEOMETRY"

    'Constants de les noves taules
    Const TRAMS2D As String = "TRAM2D"
    Const SENYALS As String = "SENYAL"
    Const IDT2D As String = "IDT2D"
    Const LCONTINUA As String = "LINIACONTINUA"
    Const LDISCONTINUA As String = "LINIADISCONTINUA"

    Private Sub frmTFC1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    '-------------------------------------------------------------------------------------------
    ' CheckBox chbDireccio: Llegeix el CheckBox de Direcci. Si est clickat snyDireccio = TRUE,
    ' si no, snyDireccio = FALSE
    '-------------------------------------------------------------------------------------------
    Private Sub chbSentit_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbSentit.CheckedChanged

        snySentit = chbSentit.Checked

    End Sub

    '-------------------------------------------------------------------------------------------
    ' CheckBox chbVelocitat: Llegeix el CheckBox de Velocitat. Si est clickat snyVelocitat = TRUE,
    ' si no, snyVelocitat = FALSE
    '-------------------------------------------------------------------------------------------
    Private Sub chbVelocitat_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbVelocitat.CheckedChanged

        snyVelocitat = chbVelocitat.Checked

    End Sub

    '-------------------------------------------------------------------------------------------
    ' CheckBox chbPasV: Llegeix el CheckBox de Pas de Vianants. Si est clickat snyPasV = TRUE,
    ' si no, snyPasV = FALSE
    '-------------------------------------------------------------------------------------------
    Private Sub chbPasV_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbPasV.CheckedChanged

        snyPasV = chbPasV.Checked

    End Sub

    '-------------------------------------------------------------------------------------------
    ' CheckBox chbCBici: Llegeix el CheckBox de Carril Bici. Si est clickat snyCBici = TRUE,
    ' si no, snyCBici = FALSE
    '-------------------------------------------------------------------------------------------
    Private Sub chbCBici_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbCBici.CheckedChanged

        snyCBici = chbCBici.Checked

    End Sub

    '-------------------------------------------------------------------------------------------
    ' CheckBox chbCPeatonal: Llegeix el CheckBox de Carrer peatonal. Si est clickat snyCPeatonal = TRUE,
    ' si no, snyCPeatonal = FALSE
    '-------------------------------------------------------------------------------------------
    Private Sub chbCPeatonal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbCPeatonal.CheckedChanged

        snyCPeatonal = chbCPeatonal.Checked

    End Sub

    '------------------------------------------------------------------------------------------
    ' ComboBox cbEscala: Representa la proporci Longitud-Amplada de la visualitzaci del tram.
    ' L'usuari elegeix una escala de la llista. En cas contrari, per defecte l'escala ser 1/1.
    '------------------------------------------------------------------------------------------   
    Private Sub cbEscala_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbEscala.SelectedIndexChanged

        Dim txtEscala1 As String

        txtEscala1 = cbEscala.Text

        Select Case txtEscala1

            Case "1/1"
                escala = 1

            Case "1/2"
                escala = 2

            Case "1/4"
                escala = 4

            Case "1/5"
                escala = 5

        End Select

    End Sub


    '-------------------------------------------------------------------------------------------
    ' Button Acceptar: 
    '-------------------------------------------------------------------------------------------
    Private Sub Acceptar_Key_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Acceptar_Key.Click

        'Try

        'Legim les BBDD d'entrada i de sortida i desem els path
        inputPath = cbCarregaDB.Text
        outputPath = cbDesaDb.Text

        'Inicialitzem el ListBox on informarem del procs
        lbResult.Items.Clear()

        'Obrim la BBDD d'entrada
        inputDB = CreateObject("Access.GDatabase")
        inputDB.OpenDatabase(inputPath)

        'Treiem la part del procs per pantalla
        lbResult.Items.Add(" Oberta base de dades d'entrada: " & inputDB.Name & ".")

        'Obrim la BBDD de sortida
        outputDB = CreateObject("Access.GDatabase")
        outputDB.OpenDatabase(outputPath)
        outputDB.BeginTrans()

        'Catch ex As Exception

        'End Try

        'Treiem la part del procs per pantalla
        lbResult.Items.Add(" Oberta base de dades de sortida: " & outputDB.Name & ".")

        'Extraiem les dades de inputDB, les transfoprmem i les desem a outputDB
        lbResult.Items.Add(" Procs d'extracci de dades de la BBDD d'entrada " & inputDB.Name & ".")
        lbResult.Items.Add(" Procs d'ompliment de dadeas a la BBDD de sortida" & outputDB.Name & ".")

        'Extraiem les dades de inputDB, les manipulem i les desem a outputDB
        manipulacioDades()

    End Sub

    '-----------------------------------------------------------------------------------------
    'Bot Cancelar: Per sortir del programa ens demana confirmaci. En cas de Si, tanca el 
    'programa. En cas de No, anula Cancelar
    '-----------------------------------------------------------------------------------------
    Private Sub Sortir_Key_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sortir_Key.Click

        If MsgBox("Vol realment sortir del programa?", vbYesNo) = vbYes Then
            End
        End If

    End Sub

    '-----------------------------------------------------------------------------------------
    'Mtode manipulacioDades(): Extreu les dades de carrils i trams i un com tractades i 
    'generats els objectes corresponets, els desa a la BBDD de sortida
    '-----------------------------------------------------------------------------------------  
    Sub manipulacioDades()

        Dim idTr As Integer, nCarr As Integer
        Dim vel As Integer, peat As Integer, bici As Integer
        Dim name As String, descrip As String
        Dim amplada As Double, x As Double, y As Double, tram As Integer
        Dim i As Integer, j As Integer
        Dim n As Integer, n2 As Integer, k As Integer
        Dim t2d As Tram2D
        Dim st As SenyalsTram
        Dim sentitTrams() As Integer

        sentitTrams = Nothing

        Try
            'Carreguem els registrs per de les BBDD d'entrada de TRAMS i de sortida TRAMS2D
            gmRS_IN_T2D = inputDB.OpenRecordset(TRAMS)
            gmRS_OUT_T2D = outputDB.OpenRecordset(TRAMS2D)

            'Cerquem el total de files de TRAMS i el guardem a n
            gmRS_IN_T2D.MoveLast()
            n = gmRS_IN_T2D.RecordCount
            'Tornem al primer Item
            gmRS_IN_T2D.MoveFirst()

            'Configurem la barra de progres
            With ProgressBar1
                .Minimum = 0
                .Maximum = n
                .Value = 0
            End With

            'Recorrem 1 a 1 les files i n'extraiem les dades per crear un Tram2D
            For i = 1 To n

                'Omplim la barra de progres
                ProgressBar1.Value = i

                'Obtenim les dades del tram2D
                idTr = gmRS_IN_T2D.GFields(IDTRAM).Value
                name = "" & gmRS_IN_T2D.GFields(NOM).Value 'D'aquesta forma evitem error per si el camp es buit
                descrip = "" & gmRS_IN_T2D.GFields(DESCR).Value  'D'aquesta forma evitem error per si el camp es buit
                nCarr = gmRS_IN_T2D.GFields(CARRILS).Value

                'Obtenim les dades del senyalsTram
                'sent = gmRS_IN_T2D.GFields(SENTIT).Value
                vel = gmRS_IN_T2D.GFields(VELOCITAT).Value
                peat = gmRS_IN_T2D.GFields(PEATONAL).Value
                bici = gmRS_IN_T2D.GFields(CBICI).Value

                'Generem un nou Tram2D i SenyalsTram
                t2d = New Tram2D(idTr, name, descrip, nCarr, escala)
                st = New SenyalsTram(idTr, vel, peat, bici, escala)

                'Inicialitzem l'objecte geomtric
                polyg = Nothing
                'Extraiem la polilnia de TRAMS 
                gmGSS.GetGeometry(gmRS_IN_T2D.GFields("Geometry"), polyg)
                If polyg.Type = "PolylineGeometry" Then
                    For j = 1 To polyg.Points.Count
                        x = polyg.Points(j).x
                        y = polyg.Points(j).y
                        t2d.generarPolilinia(x, y)
                        st.generarPolilinia(x, y)
                    Next
                End If

                'Extraiem les dades de CARRILS per acabar d'omplir els TRAMS2D i SENYALSTRAMS
                tram = t2d.tIdTram()
                QueryString = "SELECT * FROM " & CARRILS
                QueryString = QueryString & " WHERE CARRILS.IDTRAM = "
                QueryString = QueryString & tram & ";"
                gmRS_IN_ST = inputDB.OpenRecordset(QueryString)

                'Cerquem el total de files selecionades de CARRILS i el guardem a n2
                gmRS_IN_ST.MoveLast()
                n2 = gmRS_IN_ST.RecordCount
                'Tornem al primer Item
                gmRS_IN_ST.MoveFirst()
                'Inicialitzem la nova amplada
                amplada = 0

                'Omplim els arrays des sentits i amples de carril de cada tram
                For k = 1 To n2
                    t2d.setCarril(gmRS_IN_ST.GFields(AMPLE).Value, k)
                    t2d.setSentit(gmRS_IN_ST.GFields(SENTIT).Value, k)
                    st.setSentit(gmRS_IN_ST.GFields(SENTIT).Value, k)
                    gmRS_IN_ST.MoveNext()
                Next

                'Un cop tenim l'amplada, generem el polgon de tram2D
                t2d.generarPoligon()

                'Tanquem i inicialitzem de nou
                gmRS_IN_ST.Close()
                gmRS_IN_ST = Nothing

                'Insertem les dades a outputDB
                'Generem una fila nova on desar les dades
                gmRS_OUT_T2D.AddNew()
                gmRS_OUT_T2D.Update()
                'Posicionem el registre
                gmRS_OUT_T2D.MoveLast()

                'Editem el registre creat
                If gmRS_OUT_T2D.EditMode = 0 Then
                    gmRS_OUT_T2D.Edit()
                    gmRS_OUT_T2D.GFields(IDTRAM).Value = t2d.tIdTram()
                    gmRS_OUT_T2D.GFields(NOM).Value = t2d.tNom()
                    gmRS_OUT_T2D.GFields(DESCR).Value = t2d.tDescr()
                    gmRS_OUT_T2D.GFields(ESCALAT).Value = t2d.tEscala()
                    'Extraiem la polgon de TRAM2D i el desem a la columna GEOMETRY  
                    'Inicialitzem l'objecte geomtric
                    polyg = Nothing
                    polyg = New PolygonGeometry
                    'Extraiem punt a punt el poligon
                    For j = 1 To t2d.tPoligon().Points.Count
                        punt.X = t2d.tPoligon().Points.Item(j).X
                        punt.Y = t2d.tPoligon().Points.Item(j).Y
                        polyg.Points.Add(punt)
                    Next
                    'Desem el polgon al seu camp corresponent
                    gmGSS.SetGeometry(gmRS_OUT_T2D.GFields("Geometry"), polyg)
                    gmRS_OUT_T2D.Update()

                End If

                'Generem les linies separadores dels carrils
                t2d.generarLiniesCarrils()

                'Generem les imatges raster del tram
                generarRaster(st, t2d)

                'Passem a la segent fila
                gmRS_IN_T2D.MoveNext()

            Next

            'Capturem les excepcions i treiem el missatge per pantalla i en el ListBox
        Catch ex As Runtime.InteropServices.COMException
            MsgBox("COMException - frmTFC1.manipulacioDades(). Extracci de IdTram " & idTr & " fallida.")
            MsgBox(ex.Message)
            lbResult.Items.Add("COMException - frmTFC1.manipulacioDades(). Extracci de IdTram " & idTr & " fallida.")
            lbResult.Items.Add(ex.Message)
        Catch ex As AccessViolationException
            MsgBox("AccessViolationException - frmTFC1.manipulacioDades()")
            MsgBox(ex.Message)
            lbResult.Items.Add("AccessViolationException - frmTFC1.manipulacioDades()")
            lbResult.Items.Add(ex.Message)
        Catch ex As InvalidCastException
            MsgBox("InvalidCastException - frmTFC1.manipulacioDades()")
            MsgBox(ex.Message)
            lbResult.Items.Add("InvalidCastException - frmTFC1.manipulacioDades()")
            lbResult.Items.Add(ex.Message)
        Catch ex As ArgumentException
            MsgBox("InvalidCastException - frmTFC1.manipulacioDades()")
            MsgBox(ex.Message)
            lbResult.Items.Add("InvalidCastException - frmTFC1.manipulacioDades()")
            lbResult.Items.Add(ex.Message)
        Catch ex As NullReferenceException
            MsgBox("NullReferenceException - frmTFC1.manipulacioDades(). Extracci de IdTram " & idTr & " fallida.")
            MsgBox(ex.Message)
            lbResult.Items.Add("NullReferenceException - frmTFC1.manipulacioDades(). Extracci de IdTram " & idTr & " fallida.")
            lbResult.Items.Add(ex.Message)
        End Try

        'Informem dels registres desats a OutputDB
        lbResult.Items.Add(" S'ha desat a " & outputDB.Name & " " & i & " registres.")

        'Tanquem BBDD d'entrada
        lbResult.Items.Add(" Tancament base de dades d'entrada: " & inputDB.Name & ".")
        inputDB.Close()
        inputDB = Nothing


        'Tanquem BBDD de sortida
        lbResult.Items.Add(" Tancament de la base de dades de sortida: " & outputDB.Name & ".")
        outputDB.CommitTrans()
        outputDB.Close()
        outputDB = Nothing

        'Buidem la barra de progres
        ProgressBar1.Value = 0

        lbResult.Items.Add(" -- FI DEL PROCS -- ")

    End Sub

    '-----------------------------------------------------------------------------------------
    'Mtode generarRaster(): A partir de les indicacions de l'usuari, es genereran les 
    'imatges raster corresponents a les senyalitzacions ellegides per l'usuari
    '-----------------------------------------------------------------------------------------  
    Sub generarRaster(ByVal sTram As SenyalsTram, ByVal tram As Tram2D)

        Dim sny As Senyal
        sny = Nothing

        '**************************************************************************************
        'No s'inseriran Senyals de sentit de circulaci pels motius exlicats en la memria
        '**************************************************************************************

        'Generem els senyals del sentits del tram
        'If snySentit Then
        'For n = 1 To sTram.longSentit()
        '
        '
        'Next
        'End If

        '***************************************************************************************

        sny = Nothing

        'Generem els senyals de les velocitats del tram
        If snyVelocitat Then
            If sTram.scVelocitat <> 0 Then
                sTram.senyalVelocitat(sTram.scVelocitat, tram)
            End If
        End If

        sny = Nothing

        'Generem els senyals dels passos de vianants del tram
        If snyPasV Then
            sTram.senyalPasV(tram)
        End If

        sny = Nothing

        'Generem els senyals dels carrils bici del tram
        If snyCBici Then
            If (sTram.scCBici = 1) Or (sTram.scCBici = 4) Then
                sTram.senyalCBici(tram)
            End If
        End If

        sny = Nothing

        'Generem els senyals dels carrers peatonals del tram
        If snyCPeatonal Then
            If sTram.scPeatonal = 1 Then
                sTram.senyalCPeatonal(tram)
            End If
        End If

    End Sub

    '-----------------------------------------------------------------------------------------
    'Mtode inserirSenyal(): Insereix en la BBDD de sortida els objectes Senyal que li arriven
    'al cridar el mtode generarRaster()
    '----------------------------------------------------------------------------------------- 
    Sub inserirSenyal(ByVal sny As Senyal)

        Dim gmRasterGeom As Object, gmRasterServ As Object

        gmRS_OUT_SENY = outputDB.OpenRecordset(SENYALS)

        gmRasterGeom = CreateObject("GeoMedia.RasterGeometry")
        gmRasterServ = CreateObject("GeoMedia.RasterPropertiesService")

        'Inserim les dades a outputDB
        'Generem una fila nova on desar les dades
        gmRS_OUT_SENY.AddNew()
        gmRS_OUT_SENY.Update()
        'Posicionem el registre
        gmRS_OUT_SENY.MoveLast()

        'Editem el registre creat
        If gmRS_OUT_SENY.EditMode = 0 Then
            gmRS_OUT_SENY.Edit()
            gmRS_OUT_SENY.GFields(IDTRAM).Value = sny.sIdTram()
            gmRS_OUT_SENY.GFields(TIPUS).Value = sny.sTipus()
            gmRS_OUT_SENY.GFields(ESCALAT).Value = sny.sEscala()
            'Extraiem les dades raster Senyal i el desem a la columna GEOMETRY  
            gmRasterServ.FileName = sny.sPath
            gmRasterServ.GetMatrixByScaleAndOrigin(sny.sP1.X, sny.sP1.Y, sny.sP2.X, sny.sP2.Y, _
            sny.sMatriu(), sny.sRang())
            gmRasterGeom.FileName = sny.sPath
            gmRasterGeom.DisplayMatrix = sny.sMatriu
            gmGSS.SetGeometry(gmRS_OUT_SENY.GFields("Geometry"), gmRasterGeom)
            gmRS_OUT_SENY.Update()
        End If

        gmRS_OUT_SENY.MoveNext()

    End Sub

    '-----------------------------------------------------------------------------------------
    'Mtode generarLiniaContinua(): Insereix en la BBDD de sortida els objectes LINIACONTINUA
    'que li arriven al des del mtode generarLiniesCarril() de la classe Tram2D
    '----------------------------------------------------------------------------------------- 
    Sub generarLiniaContinua(ByVal linia As Linia)

        gmRS_OUT_LC = outputDB.OpenRecordset(LCONTINUA)

        'Inserim les dades a outputDB
        'Generem una fila nova on desar les dades
        gmRS_OUT_LC.AddNew()
        gmRS_OUT_LC.Update()
        'Posicionem el registre
        gmRS_OUT_LC.MoveLast()

        'Editem el registre creat
        If gmRS_OUT_LC.EditMode = 0 Then
            gmRS_OUT_LC.Edit()
            gmRS_OUT_LC.GFields(IDTRAM).Value = linia.lIdTram()
            gmRS_OUT_LC.GFields(CARRIL).Value = linia.lCarril()
            gmGSS.SetGeometry(gmRS_OUT_LC.GFields("Geometry"), linia.lPolilinia())
            gmRS_OUT_LC.Update()
        End If

        gmRS_OUT_LC.MoveNext()

    End Sub

    '-----------------------------------------------------------------------------------------
    'Mtode generarLiniaDiscontinua(): Insereix en la BBDD de sortida els objectes LINIADISCONTINUA
    'que li arriven al des del mtode generarLiniesCarril() de la classe Tram2D
    '----------------------------------------------------------------------------------------- 
    Sub generarLiniaDiscontinua(ByVal linia As Linia)

        gmRS_OUT_LD = outputDB.OpenRecordset(LDISCONTINUA)

        'Inserim les dades a outputDB
        'Generem una fila nova on desar les dades
        gmRS_OUT_LD.AddNew()
        gmRS_OUT_LD.Update()
        'Posicionem el registre
        gmRS_OUT_LD.MoveLast()

        'Editem el registre creat
        If gmRS_OUT_LD.EditMode = 0 Then
            gmRS_OUT_LD.Edit()
            gmRS_OUT_LD.GFields(IDTRAM).Value = linia.lIdTram()
            gmRS_OUT_LD.GFields(CARRIL).Value = linia.lCarril()
            gmGSS.SetGeometry(gmRS_OUT_LD.GFields("Geometry"), linia.lPolilinia())
            gmRS_OUT_LD.Update()
        End If

        gmRS_OUT_LD.MoveNext()
    End Sub

    Private Sub ProgressBar1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgressBar1.Click

    End Sub
End Class



































